/* 
 * $Id: sortejun.c,v 1.7 2007-02-08 18:05:15+09 shige Exp $
 * ۤΥȤμκġ
 * shige
 * sortejun.c
 * 02/19 2006
 * 
 * cf. http://takeno.iee.niit.ac.jp/~shige/math/lecture/misc/misc.html#sort1
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/* N: 
 * M: ο
 * K: 
 */
#define MaxN 100
#define MaxM 10
#define MaxK 10

enum {
    Last_incr=1,	/* ־夬־ */
    Last_decr,		/* ־夬 */
    Last_better,	/* ξԤΤɤ餫ᤤ */
    Last_misc		/* ¾ */
};
enum {
    Mode_ura=1,		/* ΢֤ۤǸɽˤ */
    Mode_omote,		/* ɽˤޤۤꤽΤޤ޽ */
    Mode_better,	/* 嵭 2 Ĥᤤ */
    Mode_misc		/* ¾ */
};
enum {
    Input_number=1,	/* ϤϿ */
    Input_string,	/* Ϥʸ */
    Input_misc
};
enum {
    Omode_simple=1,	/* Ϥ줿ޤ޽ */
    Omode_number,	/* ǽ */
    Omode_shless,	/* shless  */
    Omode_misc
};
enum {
    Opt_none=1,	/* Optimize ʤ */
    Opt_M,	/* M ˴ؤƱǺǾ */
    Opt_misc
};

typedef union {
    int n;
    char *s;
} Indata;

#define DefaultM 3
#define DefaultLast Last_incr
#define DefaultMode Mode_omote
#define DefaultInput Input_number
#define DefaultOpt Opt_none
#define LastPrior 1
/* LastPrior: 
 *   Mode_better && Last_better ξ硢羮ΥǥեȤɽ΢Υǥե
 *   Ȥͥ褵 1
 */
#define DefaultOMode Omode_simple
#define DefaultShlessNum 5

#define Maxbuff 8192
#define Maxstrlen 512

#define SHLESSHEAD "#shless:"
#if 0
# define AUCONN "auconn"
# define AUPLAY "| auplay"
/* ϥѥե饰ˤ */
#endif

#define Stralloc(n) ((char *)malloc((n)*sizeof(char)))

/* ##### prototype ##### */
void usage(char *comname);
int getbseq(FILE *infile,int inmode,Indata b[]);
int getarg(int argc,char *argv[],int *N,int *M,int *Last,int *Mode,
	   int *Inmode,int outmode[],int *Optimize,Indata b[]);
int getblocks(int N,int a[],int p[]);
void revarray(int N,int a[],int reva[]);
int sort1(int N,int b[],int c[],int a[]);
int sort2(int N,int inmode,Indata b[],Indata c[],int a[]);
void cparray(int len,int a[],int p[]);
int OneStep(int N,int a[],int d[],int blocks,int p[],int M,int e[]);
void putarray(int N,int a[],char *title);
void putarray2(int N,int inmode,Indata b[],char *title);
int getK(int blocks,int M);
int getOptM(int K,int N,int M,int a[],int p[],int L,int mode,
	    int *Blocks,int *Cdmode,int *Cdlast,int *IsAdd,int *CdM);
int getRunmode(int N,int M,int a[],int p[],int L,int mode,
	       int *Blocks,int *Cdmode,int *Cdlast,int *IsAdd);
void putheader(int outmode[],int N,int M,int inmode,int L,int mode,
	       int K,int cdmode,int cdlast,int cdM);
void puthistory(int outmode[],int N,int path[],int inmode,Indata b[],
	     int bn[],int cdmode,int num);
void putbody(int outmode[],int N,int M,int path[],int inmode,Indata b[],
	     int te[],int cdmode,int num);
void putshlesstop(int M,int K,int cdmode,int cdlast);
void putshlesshead(int num,int cdmode);
void putshless(int groupnum,int N,int path[],int inmode,Indata b[],int te[],
	       int cdmode,int num);
void putshlesstail(int M,int cdmode,int num);
void putmode(int N,int M,int K,int inmode,int cdmode,int cdlast);
void putpath(int N,int path[],int inmode,Indata b[],int cdmode,int num);
void putpath2(int N,int path[],int bn[],int cdmode,int num);
void putte(int N,int te[],int cdmode,int num);
int main(int argc,char *argv[]);

/* ##### ᥤ󥽡 ##### */
void usage(char *comname)
{
    fprintf(stderr,"Usage: %s [option]\n",comname);
    fprintf(stderr,"  [option]:\n");
    fprintf(stderr,"    -N[n]:  (default: ư)\n");
    fprintf(stderr,"    -M[n]: ο (default: %d)\n",DefaultM);

    fprintf(stderr,"    -L[n]: Ǹδ (default: %d)\n",DefaultLast);
    fprintf(stderr,"      [n]=%d: ־夬־\n",Last_incr);
    fprintf(stderr,"      [n]=%d: ־夬\n",Last_decr);
    fprintf(stderr,"      [n]=%d: ξԤΤɤ餫ᤤ\n",Last_better);

    fprintf(stderr,"    -I[n]: Ϸ (default: %d)\n",DefaultInput);
    fprintf(stderr,"      [n]=%d: \n",Input_number);
    fprintf(stderr,"      [n]=%d: ʸ\n",Input_string);
    
    fprintf(stderr,"    -R[n]: ư⡼ (default: %d)\n",DefaultMode);
    fprintf(stderr,"      [n]=%d: ΢֤ۤǸɽˤ\n",Mode_ura);
    fprintf(stderr,"      [n]=%d: ɽˤޤۤꤽΤޤ޽\n",Mode_omote);
    fprintf(stderr,"      [n]=%d: 嵭 2 Ĥᤤ\n",Mode_better);

    fprintf(stderr,"    -o[n](,[m]): ϥ⡼ (default: %d)\n",DefaultOMode);
    fprintf(stderr,"      [n]=%d: ñ\n",Omode_simple);
    fprintf(stderr,"      [n]=%d: źǽ\n",Omode_number);
    fprintf(stderr,"      [n]=%d: shless Ѥν",Omode_shless);
    fprintf(stderr," ([m]: ޤȤϤθĿ (default: %d))\n",DefaultShlessNum);
    fprintf(stderr,"    -O[n]: Ŭ (default: %d)\n",DefaultOpt);
    fprintf(stderr,"      [n]=%d: Ŭʤ\n",Opt_none); 
    fprintf(stderr,"      [n]=%d: ƱˤʤǾ M \n",Opt_M); 

    fprintf(stderr,"1) ¤ϡ %dο %d\n",MaxN,MaxM);
    fprintf(stderr,"2) ǡɸϤ롣\n");
    fprintf(stderr,"3) ǡˤƱΤϴޤޤʤȤ롣\n");
    fprintf(stderr,"4) ǡʸξϡɤߤߡ");
    fprintf(stderr,"ʸκĹ %d Ȥ롣\n",Maxstrlen);

    return;
}

int getbseq(FILE *infile,int inmode,Indata b[])
{
    int j=0,len;
    char buff[Maxbuff],*s;

    if(inmode==Input_number){
	while(fgets(buff,Maxbuff,infile)!=NULL){
	    if(strlen(buff)>=Maxbuff-1) return -1;
	    s=buff;
	    if((s=strtok(s," \t\n"))!=NULL){
		do{
		    if(++j>MaxN) return -2;
		    b[j-1].n=atoi(s);
		    s=strtok(NULL," \t\n");
		}while(s!=NULL);
	    }
	}
    }
    else{
	while(fgets(buff,Maxbuff,infile)!=NULL){
	    if((len=strlen(buff))>=Maxbuff-1 || len<=0) return -11;
	    else if(len>Maxstrlen+1) return -12;
	    if(buff[len-1]!='\n') return -13;
	    else buff[len-1]='\0';
	    if(++j>MaxN) return -14;
	    if((b[j-1].s=Stralloc(len+1))==NULL) return -15;
	    strcpy(b[j-1].s,buff);
	}
    }
    return j;
}

int getarg(int argc,char *argv[],int *N,int *M,int *Last,int *Mode,
	   int *Inmode,int outmode[],int *Optimize,Indata b[])
{
    int j;

    *N=-1;
    *M=DefaultM;
    *Mode=DefaultMode;
    *Last=DefaultLast;
    *Inmode=DefaultInput;
    outmode[0]=DefaultOMode; outmode[1]=DefaultShlessNum;
    *Optimize=DefaultOpt;
    /* option μ */
    if(argc>1){
	j=0;
	while(++j<argc){
	    if(*argv[j]!='-') return -1;
	    switch(*(++argv[j])){
	    case 'h': return -2;
	    case 'N':
		if(*(++argv[j])=='\0' && ++j>=argc) return -3;
		if((*N=atoi(argv[j]))<=1 || *N>MaxN) return -4;
		break;
	    case 'M':
		if(*(++argv[j])=='\0' && ++j>=argc) return -3;
		if((*M=atoi(argv[j]))<=1 || *M>MaxM) return -5;
		break;
	    case 'L':
		if(*(++argv[j])=='\0' && ++j>=argc) return -3;
		if((*Last=atoi(argv[j]))<=0 || *Last>=Last_misc) return -6;
		break;
	    case 'I':
		if(*(++argv[j])=='\0' && ++j>=argc) return -3;
		if((*Inmode=atoi(argv[j]))<=0 || *Inmode>=Input_misc) return -6;
		break;
#if 0
	    case 'm':
		if(strncmp(argv[j],"mode",4)) return -7;
		else argv[j]+=4;
#endif
	    case 'R':
		if(*(++argv[j])=='\0' && ++j>=argc) return -3;
		if((*Mode=atoi(argv[j]))<=0 || *Mode>=Mode_misc) return -8;
		break;
	    case 'o':
		if(*(++argv[j])=='\0' && ++j>=argc) return -3;
		if((outmode[0]=*argv[j]-'0')<=0 || outmode[0]>=Omode_misc) 
		  return -9;
		if(*(argv[j]+1)==',') outmode[1]=atoi(argv[j]+2);
		break;
	    case 'O':
		if(*(++argv[j])=='\0' && ++j>=argc) return -3;
		if((*Optimize=atoi(argv[j]))<=0 || *Optimize>=Opt_misc) 
		  return -10;
		break;
	    default:
		return -11;
	    }
	}
    }
    /* b[] μ */
    if((j=getbseq(stdin,*Inmode,b))<=1) return j-20;
    if(*N>0){ if(j!=*N) return -9; }
    else *N=j;
    return 0;
}

/* å֥å (1 ʾ) å֥åƬ (p[]) ֤
 */
int getblocks(int N,int a[],int p[])
{
    int ind=0,j;

    if(p!=NULL) p[0]=0;
    for(j=1;j<N;j++){
	if(a[j-1]>a[j]){ ind++; if(p!=NULL) p[ind]=j; }
	else if(a[j-1]==a[j]) return -1;
    }
    return ind+1;
}

void revarray(int N,int a[],int reva[])
{
    int j;

    for(j=1;j<=N;j++) reva[j-1]=a[N-j];
}

/* a[] ϻĤƤơǤʤ a[] Υȥ졼ĤȤˤ롣
 * СǤʤв (ȹԤ) Ϥ뤳ȤǤ롣
 */ 


/* b[] 򾺽 c[] ˥Ȥʤ b[a[j]]=c[j] Ȥʤ a[] 
 * ٤
 * Τ뤫 check ԤäƤ롣
 *
 * ϡʣΥ֥åޡΤ򥽡ȤơΥ֥
 * ֹΤˤȤ롣
 * q1[] = ʣΥ֥å¤٤
 * r[]: r1[i] = q1[i] ֥åܤ (֥åֹ) ɽ魯
 * Ȥ sort1(q1,q2,s,m)  q2[i] Υ֥åֹ = r1[s[i]] Ȥʤ
 * (q2[i]=q1[s[i]])Ǽ¸Ԥʤ롣
 */ 
int sort1(int N,int b[],int c[],int a[])
{
    int j,k;

    if(N<=0) return -1;
    c[0]=b[0]; a[0]=0;
    for(j=1;j<N;j++){
	for(k=j-1;k>=0;k--){
	    if(b[j]==c[k]) return -2;
	    else if(b[j]<c[k]){ c[k+1]=c[k]; a[k+1]=a[k]; }
	    else break;
	}
	c[k+1]=b[j]; a[k+1]=j;
    }
    return 0;
}

int sort2(int N,int inmode,Indata b[],Indata c[],int a[])
{
    int j,k,ret;

    if(N<=0) return -1;
    a[0]=0;
    if(inmode==Input_number){
	c[0].n=b[0].n; 
	for(j=1;j<N;j++){
	    for(k=j-1;k>=0;k--){
		if(b[j].n==c[k].n) return -2;
		else if(b[j].n<c[k].n){ c[k+1].n=c[k].n; a[k+1]=a[k]; }
		else break;
	    }
	    c[k+1].n=b[j].n; a[k+1]=j;
	}
    }
    else{
	c[0].s=b[0].s; 
	for(j=1;j<N;j++){
	    for(k=j-1;k>=0;k--){
		if((ret=strcmp(b[j].s,c[k].s))==0) return -2;
		else if(ret<0){ c[k+1].s=c[k].s; a[k+1]=a[k]; }
		else break;
	    }
	    c[k+1].s=b[j].s; a[k+1]=j;
	}
    }
    return 0;
}

void cparray(int len,int a[],int p[])
{
    int j;
    for(j=1;j<=len;j++) p[j-1]=a[j-1];
}

/* One step κ:
 * a[N] -> d[N] ᤹μ = e[N] ¸롣
 * p[blocks]: å֥åƬ
 */
int OneStep(int N,int a[],int d[],int blocks,int p[],int M,int e[])
{
    int div,rest;
    int n,save[N],*dp,*ep,s[N],bn[N],p0[blocks+1];
    int len0=0,len,j,k,m;
    int mark[M]; /* ƻθߤΥ֥åֹ¸ */
		   
    if(blocks<=0 ||N<=0||M<=1) return -1;
    if(blocks==1) return 0;
    div=blocks/M; rest=blocks%M;
    mark[0]=1;
    for(j=1;j<=rest;j++) mark[j]=mark[j-1]+div+1;
    for(j=rest+1;j<M;j++) mark[j]=mark[j-1]+div;

    for(j=1;j<=blocks;j++) p0[j-1]=p[j-1];
    p0[blocks]=N;

    p[0]=0; dp=d; ep=e;

    for(n=1;n<=div;n++){
	if(n>=2){ p[n-1]=p[n-2]+len0; dp+=len0; ep+=len0; }
	len0=0;
	for(j=0;j<M;j++){
	    len=p0[mark[j]]-p0[mark[j]-1];
	    /* a[]  mark[j] ܤΥ֥å save ˥ԡ */
	    cparray(len,a+p0[mark[j]-1],save+len0);
	    for(k=len0;k<len0+len;k++) bn[k]=j; /* ֹ (0~M-1) */
	    len0+=len;
	}
	if(sort1(len0,save,dp,s)<0) return -2;	
	/* save2[i] λֹ bn[s[i]] */
	for(j=0;j<len0;j++) ep[j]=bn[s[j]];
	for(j=0;j<M;j++) mark[j]++;
    }
    m=div;
    if(rest){
	if(++m>=2){ p[m-1]=p[m-2]+len0; dp+=len0; ep+=len0; }
	len0=0;
	for(j=0;j<rest;j++){
	    len=p0[mark[j]]-p0[mark[j]-1];
	    /* a[]  mark[j] ܤΥ֥å save ˥ԡ */
	    cparray(len,a+p0[mark[j]-1],save+len0);
	    for(k=len0;k<len0+len;k++) bn[k]=j; /* ֹ (0~M-1) */
	    len0+=len;
	}
	if(sort1(len0,save,dp,s)<0) return -3;
	/* save2[i] λֹ bn[s[i]] */
	for(j=0;j<len0;j++) ep[j]=bn[s[j]];
    }
    return m;
}

void putarray(int N,int a[],char *title)
{
    int j;

    printf("%s: %d",title,a[0]);
    for(j=2;j<=N;j++) printf(",%d",a[j-1]);
    printf("\n");
}

void putarray2(int N,int inmode,Indata b[],char *title)
{
    int j;

    if(inmode==Input_number){
	printf("%s: %d",title,b[0].n);
	for(j=2;j<=N;j++) printf(",%d",b[j-1].n);
	printf("\n");
    }
    else{
	printf("%s:\n",title);
	for(j=1;j<=N;j++) printf("  [%s]\n",b[j-1].s);
    }
}

/* M^(k-1)<blocks<=M^k ʤ k ֤ */
int getK(int blocks,int M)
{
    if(blocks<=0 || M<=1) return -1;
    else return (int)(ceil(log(blocks)/log(M)));
}

/* opt==Opt_M ΤȤ M () μľ */
int getOptM(int K,int N,int M,int a[],int p[],int L,int mode,
	    int *Blocks,int *Cdmode,int *Cdlast,int *IsAdd,int *CdM)
{
    int newK,m;
    int blocks,cdmode,cdlast,isadd;
    int tmpa[MaxN];
    
    *CdM=M;
    if(M==2) return K;
    cparray(N,a,tmpa);
    for(m=M-1;m>=2;m--){
	newK=getRunmode(N,m,tmpa,p,L,mode,&blocks,&cdmode,&cdlast,&isadd);
	if(newK<0) return newK;
	if(newK>K) break;
    }
    if(m==M-1) return K;
    *CdM=m+1;
    return getRunmode(N,M,a,p,L,mode,Blocks,Cdmode,Cdlast,IsAdd);
}

/* ºݤư⡼ɤꤹ 
 * ä simple ˤǤʤ ?
 */
int getRunmode(int N,int M,int a[],int p[],int L,int mode,
	       int *Blocks,int *Cdmode,int *Cdlast,int *IsAdd)
{
    int K,k1,k2,k3,k4;
    int rev;
    int flag;

    rev=0;
    if((*Blocks=getblocks(N,a,p))<0) return -1;
    *Cdmode=mode; *Cdlast=L; *IsAdd=0;
    k1=getK(*Blocks,M);
    k2=getK(N+1-*Blocks,M); /* for reverse */

    if(mode==Mode_ura){
	if(L==Last_incr) K=k1;
	else if(L==Last_decr){ rev=1; K=k2; }
	else{ /* L==Last_better */
	    if(k1<k2){ K=k1; *Cdlast=Last_incr; }
	    else if(k1>k2){ rev=1; K=k2; *Cdlast=Last_decr; }
	    else{ /* k1==k2 */
		K=k1;
		if(DefaultLast == Last_decr){ /* Last_decr ͥξ */
		    rev=1; *Cdlast=Last_decr; 
		}
		else *Cdlast=Last_incr;
	    }
	}
    }
    else if(mode==Mode_omote){
	if(L==Last_incr){
	    k3=(k1%2==1)?(k1+1):k1; 
	    k4=(k2%2==0)?(k2+1):k2;
	    if(k3<k4){ K=k1; if(k1!=k3) *IsAdd=1; }
	    else{ rev=1; K=k2; if(k2!=k4) *IsAdd=1; }
	}
	else if(L==Last_decr){
	    k3=(k1%2==0)?(k1+1):k1;
	    k4=(k2%2==1)?(k2+1):k2;
	    if(k3<k4){ K=k1; if(k1!=k3) *IsAdd=1; }
	    else{ rev=1; K=k2; if(k2!=k4) *IsAdd=1; }
	}
	else{ /* L==Last_better */
	    if(k1<k2){ 
		K=k1; 
		if(k1%2==1) *Cdlast=Last_decr; 
		else *Cdlast=Last_incr;
	    }
	    else if(k1>k2){ 
		rev=1; K=k2; 
		if(k2%2==1) *Cdlast=Last_incr;
		else *Cdlast=Last_decr;
	    }
	    else{ /* k1==k2 */
		K=k1;
		if(DefaultLast==Last_decr){ /* Last_decr ͥξ */
		    *Cdlast=Last_decr;
		    if(k1%2==0) rev=1;
		}
		else{ /* Last_incr ͥξ */
		    *Cdlast=Last_incr;
		    if(k1%2==1) rev=1;
		}
	    }
	}
    }
    else{ /* mode==Mode_better */
	if(L==Last_incr){
	    /* ΢  k1ɽ k1 (even ΤȤ)ɽ k2 (odd ΤȤ) */
	    k4=(k2%2==0)?(k2+1):k2;
	    if(k1>k4){ 
		rev=1;
		K=k2;
		if(k2!=k4) *IsAdd=1;
		*Cdmode=Mode_omote;
	    }
	    else if(k1<k4){
		K=k1;
		if(k1%2==1) *Cdmode=Mode_ura;
		else if(DefaultMode == Mode_ura) *Cdmode=Mode_ura;
		else *Cdmode=Mode_omote;
	    }
	    else{ /* k1==k4 */
		if(DefaultMode == Mode_ura){ /* Mode_ura ͥξ */
		    K=k1; *Cdmode=Mode_ura;
		}
		else{ /* Mode_omote ͥξ */
		    *Cdmode=Mode_omote;
		    if(k1%2==0) K=k1;
		    else{ rev=1; K=k2; if(k2!=k4) *IsAdd=1; }
		}
	    }
	}
	else if(L==Last_decr){
	    k3=k1;
	    if(k1%2==0) k3++;
	    if(k3<k2){
		K=k1;
		if(k1!=k3) *IsAdd=1;
		*Cdmode=Mode_omote;
	    }
	    else if(k3>k2){
		rev=1;
		K=k2;
		if(k2%2==1) *Cdmode=Mode_ura;
		else if(DefaultMode == Mode_ura) *Cdmode=Mode_ura;
		else *Cdmode=Mode_omote;
	    }
	    else{ /* k3==k2 */
		if(DefaultMode == Mode_ura){ /* Mode_ura ͥξ */
		    rev=1; K=k2; *Cdmode=Mode_ura; 
		}
		else{ /* Mode_omote ͥξ */
		    *Cdmode=Mode_omote;
		    if(k1%2==1){ K=k1; if(k1!=k3) *IsAdd=1; }
		    else{ rev=1; K=k2; }
		}
	    }
	}
	else{ /* L==Last_better */
	    if(k1<k2){ /* k1 */
		flag=k1%2;
		K=k1; 
		if(DefaultMode == Mode_ura){ /* ΢ */
		    if(DefaultLast == Last_decr && flag && LastPrior){
			/* 夬硢k1 羮ɽ΢ͥ */ 
			*Cdmode=Mode_omote; *Cdlast=Last_decr;
		    }			
		    else{ *Cdmode=Mode_ura; *Cdlast=Last_incr; }
		}
		else{ /* Mode_omote */ 
		    if(DefaultLast == Last_incr && flag && LastPrior){
			/* 夬k1 羮ɽ΢ͥ */ 
			*Cdmode=Mode_ura; *Cdlast=Last_incr;
		    }
		    else{
			*Cdmode=Mode_omote;
			*Cdlast=(flag)?Last_decr:Last_incr;
		    }
		}
	    }
	    else if(k1>k2){
		flag=k2%2;
		K=k2; rev=1;
		if(DefaultMode == Mode_ura){ /* ΢ */
		    if(DefaultLast == Last_incr && flag && LastPrior){
			/* 夬k1 羮ɽ΢ͥ */ 
			*Cdmode=Mode_omote; *Cdlast=Last_incr;
		    }			
		    else{ *Cdmode=Mode_ura; *Cdlast=Last_decr; }
		}
		else{ /* Mode_omote */ 
		    if(DefaultLast == Last_decr && flag && LastPrior){
			/* 夬硢k1 羮ɽ΢ͥ */ 
			*Cdmode=Mode_ura; *Cdlast=Last_decr;
		    }
		    else{
			*Cdmode=Mode_omote;
			*Cdlast=(flag)?Last_incr:Last_decr;
		    }
		}
	    }
	    else{ /* k1==k2 */
		flag=k1%2;
		K=k1; *Cdmode=DefaultMode; *Cdlast=DefaultLast;
		if((DefaultMode==Mode_ura && DefaultLast==Last_decr) 
		   ||(DefaultMode==Mode_omote && DefaultLast==Last_decr && !flag)
		   ||(DefaultMode==Mode_omote && DefaultLast==Last_incr && flag))
		  rev=1;
	    }
	}
    }
    if(rev){
	int reva[N];

	revarray(N,a,reva);
	cparray(N,reva,a);
	*Blocks=N+1-*Blocks;
	getblocks(N,a,p);
    }
    return K;
}
    
void putheader(int outmode[],int N,int M,int inmode,int L,int mode,
	       int K,int cdmode,int cdlast,int cdM)
{
    if(outmode[0]==Omode_simple || outmode[0]==Omode_number){
	printf("# N=%d, M=%d, K=%d\n",N,cdM,K);
	if(M!=cdM) printf("# (ꤷ M=%d)\n",M);
	printf("# %sϡ",(inmode==Input_number)?"":"ʸ");
	printf("%s%s",(cdmode==Mode_omote)?"ɽ":"΢","");
	printf("夬%s\n",(cdlast==Last_incr)?"Ǿ":"");
	if(mode!=cdmode){
	    printf("# (ꤷ:");
	    if(mode==Mode_better) printf(" Ŭ)\n");
	    else printf(")\n"); /* ʤϤ */
	}
	if(L!=cdlast){
	    printf("# (ꤷ:");
	    if(L==Last_better) printf(" ®)\n");
	    else printf(")\n"); /* ʤϤ */
	}
    }
    else if(outmode[0]==Omode_shless)
      putshlesstop(M,K,cdmode,cdlast);
}

/* num<0 ΤȤ mode = cdlast, ʳ mode=cdmode */
void puthistory(int outmode[],int N,int path[],int inmode,Indata b[],
	     int bn[],int cdmode,int num)
{
    if(outmode[0]==Omode_simple){
	putpath(N,path,inmode,b,cdmode,num);
    }
    else if(outmode[0]==Omode_number){
	putpath2(N,path,bn,cdmode,num);
    }
}

/* num<0 ΤȤ mode = cdlast, ʳ mode=cdmode */
void putbody(int outmode[],int N,int M,int path[],int inmode,Indata b[],
	     int te[],int cdmode,int num)
{
    if(outmode[0]==Omode_simple){
	putte(N,te,cdmode,num);
    }
    else if(outmode[0]==Omode_number){
	putte(N,te,cdmode,num);
    }
    else if(outmode[0]==Omode_shless){
	putshlesshead(num,cdmode);
	putshless(outmode[1],N,path,inmode,b,te,cdmode,num);
	putshlesstail(M,cdmode,num);
    }
}

void putshlesstop(int M,int K,int cdmode,int cdlast)
{
    printf("%s ɬײ = [%d]־ = [%s]\n ",SHLESSHEAD,
	   K,(cdlast==Last_incr)?"Ǿ":"");
    printf("%s",AUCONN);
    printf(" i chi ba n u e o null"); /* 1 ־ */
    if(cdlast==Last_incr) printf(" sa i sho o"); /* ֺǾ */
    else printf(" sa i da i"); /* ֺ */
    printf(" ni su ru no ni null"); /* ֤ˤΤˡ */
    /* ### K  2 οΤ support ### */
    if(K>=20) printf(" %d",K/10);
    if(K>=10) printf(" 10");
    if(K%10) printf(" %d",K%10);
    printf(" ka i ka ka ri ma su"); /* ֤ޤ */
    printf(" %s\n",AUPLAY);

    printf("%s ο = [%d] = [%s]\n",SHLESSHEAD,
	M,(cdmode==Mode_ura)?"΢֤":"ɽΤޤ");
    printf("%s",AUCONN);
    printf(" ka mi wa null"); /* ֻϡ */
    if(cdmode==Mode_ura) 
      printf(" u ra ga e si na ga ra"); /* ΢֤ʤ */
    else printf(" o mo te no ma ma"); /* ɽΤޤޡ */
    printf(" si te i si ta ba n go u no ya ma ni ku ba ttsu te ku da sa i");
    /* ֻꤷֹλۤäƲ */
    printf(" %s\n",AUPLAY);
}

void putshlesshead(int num,int cdmode)
{
    if(num<0) num=-num;
    printf("%s [%d ܳ]\n",SHLESSHEAD,num);
    printf("%s %d ka i me ka i si %s\n",AUCONN,num,AUPLAY);
    /* %d ܳϡ */
}

/* num<0 ΤȤ te==NULL */
void putshless(int groupnum,int N,int path[],int inmode,Indata b[],int te[],
	       int cdmode,int num)
{
    int j,k,max=0;
    int tej,pathj;
    int runmode,lastj;
    int rev;

    if(num<0){ 
	runmode=0; /* Ǹ֤ */
	rev = (cdmode==Mode_omote && (-num)%2==0);
    }
    else if(cdmode==Mode_ura) runmode=1; /*  */
    else if(num%2==0) runmode=2; /* ž */
    else runmode=3; /* ȿž */
    if(runmode==3){
	for(j=1;j<=N;j++) if(te[j-1]>max) max=te[j-1];
    }
    if(groupnum>0){
	lastj=0;
	printf("%s",SHLESSHEAD);
	for(j=1;j<=N;j++){
	    if(runmode==0){ 
		if(rev) pathj=path[N-j];
		else pathj=path[j-1];
		tej=1; 
	    }
	    else if(runmode==1){ pathj=path[j-1]; tej=te[j-1]+1; }
	    else if(runmode==2){ pathj=path[N-j]; tej=te[N-j]+1; }
	    else{ pathj=path[j-1]; tej=max-te[j-1]+1; }
	    if(inmode==Input_number)
	      printf(" [%d --> %d]",b[pathj].n,tej);
	    else
	      printf(" [%s --> %d]",b[pathj].s,tej);
	    if(j%groupnum==0){
		printf("\n%s",AUCONN);
		for(k=lastj+1;k<=j;k++){
		    if(runmode==0) tej=1;
		    else if(runmode==1) tej=te[k-1]+1;
		    else if(runmode==2) tej=te[N-k]+1;
		    else tej=max-te[k-1]+1;
		    printf(" %d",tej);
		}
		printf(" %s\n",AUPLAY);
		if(j<N) printf("%s",SHLESSHEAD);
		lastj=j;
	    }
	    else if(j<N) printf("\\n");
	}
	if(lastj<N){
	    printf("\n%s",AUCONN);
	    for(k=lastj+1;k<=N;k++){
		if(runmode==0) tej=1;
		else if(runmode==1) tej=te[k-1]+1;
		else if(runmode==2) tej=te[N-k]+1;
		else tej=max-te[k-1]+1;
		printf(" %d",tej);
	    }
	    printf(" %s\n",AUPLAY);
	}
    }
    else{
	printf("%s",SHLESSHEAD);
	for(j=1;j<=N;j++){
	    if(runmode==0){
		if(rev) pathj=path[N-j];
		else pathj=path[j-1];
		tej=1; 
	    }
	    else if(runmode==1){ pathj=path[j-1]; tej=te[j-1]+1; }
	    else if(runmode==2){ pathj=path[N-j]; tej=te[N-j]+1; }
	    else{ pathj=path[j-1]; tej=max-te[j-1]+1; }
	    if(inmode==Input_number)
	      printf(" [%d --> %d]",b[pathj].n,tej);
	    else
	      printf(" [%s --> %d]",b[pathj].s,tej);
	    if(j<N) printf("\\n");
	}
	printf("\n%s",AUCONN);
	for(j=1;j<=N;j++){
	    if(runmode==0) tej=1;
	    else if(runmode==1) tej=te[j-1]+1;
	    else if(runmode==2) tej=te[N-j]+1;
	    else tej=max-te[j-1]+1;
	    for(k=1;k<=-groupnum;k++) printf(" null");
	    printf(" %d",tej);
	}
	printf(" %s\n",AUPLAY);
    }
}

void putshlesstail(int M,int cdmode,int num)
{
    int j;
    
    printf("%s [%d ܽλ]\n",SHLESSHEAD,(num<0)?(-num):num);
    printf("%s",AUCONN);
    for(j=1;j<=M;j++) printf(" %d",j);
    printf(" no ju n ni null 1 ga i chi ba n"); /* ֤νˡ1 ֡ */
    if(cdmode==Mode_ura) printf(" si ta"); /* ֲ */
    else printf(" u e");  /* ־ */
    printf(" ni na ru yo o ni ka sa ne te"); /* ֤ˤʤ褦ˤͤơ */
    if(cdmode==Mode_ura) printf(" null u ra ka e si te"); /* ֡΢֤ơ */
    printf(" ku da sa i %s\n",AUPLAY); /* ֲ */
    if(num<0){
	printf("%s",AUCONN);
	printf(" ko re de null shu u ryo o de su %s\n",AUPLAY);
	/* ֤ǽλǤ */
    }
}

void putmode(int N,int M,int K,int inmode,int cdmode,int cdlast)
{
    printf("# (N,M)=(%d,%d), K=%d\n",N,M,K);
    printf("# %s%s",(cdmode==Mode_omote)?"ɽ":"΢","");
    printf("夬%s",(cdlast==Last_incr)?"Ǿ":"");
    printf("%s\n",(inmode==Input_number)?"":"ʸ");
}

void putpath(int N,int path[],int inmode,Indata b[],int cdmode,int num)
{
    int j,rev;

    if(num<0){
#ifdef DEBUG2
	printf("DEBUG2: (cdmode,-num)=(%d,%d)\n",cdmode,-num);
#endif
	if(cdmode==Mode_omote && (-num)%2==1) rev=1;
	else rev=0;
    }
    else if(cdmode==Mode_omote && num%2==0) rev=1;
    else rev=0;

    if(inmode==Input_number){
	printf("#");
	if(rev) for(j=1;j<=N;j++) printf(" %d",b[path[N-j]].n); /* ž */
	else for(j=1;j<=N;j++) printf(" %d",b[path[j-1]].n); /*  */
	printf("\n");
    }
    else{
	if(rev) for(j=1;j<=N;j++) printf("# %s\n",b[path[N-j]].s); /* ž */
	else for(j=1;j<=N;j++) printf("# %s\n",b[path[j-1]].s); /*  */
    }
}

void putpath2(int N,int path[],int bn[],int cdmode,int num)
{
    int j,rev;

    printf("#");
    if(num<0){
#ifdef DEBUG2
	printf("DEBUG2: (cdmode,-num)=(%d,%d)\n",cdmode,-num);
#endif
	if(cdmode==Mode_omote && (-num)%2==1) rev=1;
	else rev=0;
    }
    else if(cdmode==Mode_omote && num%2==0) rev=1;
    else rev=0;

    if(rev) for(j=1;j<=N;j++) printf(" %d",bn[path[N-j]]);  /* ž */
    else for(j=1;j<=N;j++) printf(" %d",bn[path[j-1]]); /*  */
    printf("\n");
}

void putte(int N,int te[],int cdmode,int num)
{
    int j,max;

    printf(" ");
    if(num<0) for(j=1;j<=N;j++) printf(" %d",1);
    else if(cdmode == Mode_omote){
	if(num%2==0) /* ž */
	  for(j=1;j<=N;j++) printf(" %d",te[N-j]+1);
	else{ /* ȿž */
	    max=0;
	    for(j=1;j<=N;j++) if(te[j-1]>max) max=te[j-1];
	    for(j=1;j<=N;j++) printf(" %d",max-te[j-1]+1);
	}
    }
    else /*  */
      for(j=1;j<=N;j++) printf(" %d",te[j-1]+1);
    printf("\n");
}

int main(int argc,char *argv[])
{
    int a[MaxN],d[MaxN],p[MaxN];
    int bn[MaxN];
    int te[MaxK][MaxN],path[MaxK+1][MaxN];
    int N,M,L,mode,inmode,outmode[2];
    Indata b[MaxN],c[MaxN];
    int j,ret,K,blocks;
    int isAdd=0; /* Ǹ 1 դˤΤɲä뤫ɤ */
    int cdmode,cdlast; /* 򤵤줿ۤ/ǽ */
    int opt,cdM; /* ŬˤäƼľ줿 M */

    if((ret=getarg(argc,argv,&N,&M,&L,&mode,&inmode,outmode,&opt,b))<0){
	usage(argv[0]);
	return 1;
    }
    if((ret=sort2(N,inmode,b,c,a))<0){
	/* error */
	return 2;
    }
    for(j=1;j<=N;j++) bn[a[j-1]]=j;
#if defined(DEBUG1) || defined(DEBUG2)
    putarray2(N,inmode,b,"DEBUG b[]");
    putarray2(N,inmode,c,"DEBUG c[]");
    putarray(N,a,"DEBUG a[]");
    putarray(N,bn,"DEBUG bn[]");
#endif
    /*  mode ˤäƿ */
    if((K=getRunmode(N,M,a,p,L,mode,&blocks,&cdmode,&cdlast,&isAdd))<0){
      /* error */
	return 3;
    }
    if(opt==Opt_M){
	K=getOptM(K,N,M,a,p,L,mode,&blocks,&cdmode,&cdlast,&isAdd,&cdM);
	if(K<0){
	    /* error */
	    return 3;
	}
    }
    else cdM=M;
#if defined(DEBUG1) || defined(DEBUG2)
    putarray(N,a,"DEBUG a[]");
    putarray(blocks,p,"DEBUG p[]");
    printf("DEBUG: (N,M,blocks,K)=(%d,%d,%d,%d)\n",N,M,blocks,K);
    printf("DEBUG: (mode,cdmode,cdlast,isAdd,cdM,opt)=(%d,%d,%d,%d,%d,%d)\n",
       mode,cdmode,cdlast,isAdd,cdM,opt);
#endif
    if(K+isAdd<=0) return 0;
    else if(K>MaxK) return 20-ret;
    cparray(N,a,path[0]);
#ifdef DEBUG2
    printf("DEBUG2: path[0]"); putarray(N,path[0],"");
#endif
    for(j=1;j<=K;j++){
	if((blocks=OneStep(N,a,d,blocks,p,cdM,te[j-1]))<0) return 30-ret;
	cparray(N,d,a);
	cparray(N,d,path[j]);
#ifdef DEBUG1
	putarray(N,a,"DEBUG a[]");
	putarray(blocks,p,"DEBUG p[]");
#endif
#ifdef DEBUG2
	printf("DEBUG2: path[%d]",j); putarray(N,path[j],"");
	printf("DEBUG2: te[%d]",j-1); putarray(N,te[j-1],"");
#endif
    }
    putheader(outmode,N,M,inmode,L,mode,K+isAdd,cdmode,cdlast,cdM);
    for(j=K;j>=1;j--){
	puthistory(outmode,N,path[j],inmode,b,bn,cdmode,K-j+1);
	putbody(outmode,N,cdM,path[j],inmode,b,te[j-1],cdmode,K-j+1);
    }
    puthistory(outmode,N,path[0],inmode,b,bn,cdmode,K+1);
    if(isAdd){
	putbody(outmode,N,cdM,path[0],inmode,b,NULL,cdmode,-K-1);
	puthistory(outmode,N,path[0],inmode,b,bn,cdmode,-K-1);
    }
    return 0;
}
