/* auconn.c إåե
 * 05/29 2000
 * shige
 * auconn.h
 *
 * $Id: auconn.h,v 1.17 2007-01-07 21:12:48+09 shige Exp $
 */
#ifndef __AUCONN_H__
#define __AUCONN_H__

#include <stdio.h>
#include <stdlib.h>

#include "cstruct.h"
#include "conf.h"
#include "error.h"
#include "common.h"

#ifdef __AUCONN_C__
#define Maxdatanum 1000
#define Maxopenmode 3

double Mintimes=0.005;
int verbose=1;
int listonly=0;
FILE *tmpfile1=NULL;

#define StrOrNull(s) (((s)!=NULL)?(s):"")

char *CommandNames[]={"auconn","wavconn","aiffconn"};

#ifdef AUDEFAULTPATHLIST
#define AU_Pathlist AUDEFAULTPATHLIST
#else
#define AU_Pathlist "/usr/local/audio/lib/audata:"
#endif
#ifdef WAVDEFAULTPATHLIST
#define WAV_Pathlist WAVDEFAULTPATHLIST
#else
#define WAV_Pathlist "/usr/local/audio/lib/wavdata:"
#endif
#ifdef AIFFDEFAULTPATHLIST
#define AIFF_Pathlist AIFFDEFAULTPATHLIST
#else
#define AIFF_Pathlist "/usr/local/audio/lib/aiffdata:"
#endif
#define AU_Extlist ".au:.AU:"
#define AU_Conffname "~/.auconnrc"
#define AU_ExtEnvname "AUDATAEXT"
#define AU_PathEnvname "AUDATAPATH"
#define AU_NULLFEnvname "AUNULLFILE"
#define WAV_Extlist ".wav:.WAV:"
#define WAV_Conffname "~/.wavconnrc"
#define WAV_ExtEnvname "WAVDATAEXT"
#define WAV_PathEnvname "WAVDATAPATH"
#define WAV_NULLFEnvname "WAVNULLFILE"
#define AIFF_Extlist ".aif:.aiff:.AIF:.AIFF:"
#define AIFF_Conffname "~/.aiffconnrc"
#define AIFF_ExtEnvname "AIFFDATAEXT"
#define AIFF_PathEnvname "AIFFDATAPATH"
#define AIFF_NULLFEnvname "AIFFNULLFILE"

#if 0
char *DEFAULTExtlist[] 	   ={AU_Extlist,     WAV_Extlist,     AIFF_Extlist};
char *DEFAULTPathlist[]    ={AU_Pathlist,    WAV_Pathlist,    AIFF_Pathlist};
char *DEFAULTConffname[]   ={AU_Conffname,   WAV_Conffname,   AIFF_Conffname};
char *DEFAULTExtEnvname[]  ={AU_ExtEnvname,  WAV_ExtEnvname,  AIFF_ExtEnvname};
char *DEFAULTPathEnvname[] ={AU_PathEnvname, WAV_PathEnvname, AIFF_PathEnvname};
char *DEFAULTNULLFEnvname[]={AU_NULLFEnvname,WAV_NULLFEnvname,AIFF_NULLFEnvname};
#else
char *DEFAULTExtlist;
char *DEFAULTPathlist;
char *DEFAULTConffname;
char *DEFAULTExtEnvname;
char *DEFAULTPathEnvname;
char *DEFAULTNULLFEnvname;
#endif

/* ##### defined in conf.h ##### */
extern char *NULLFname,*undefs;
#endif /* __AUCONN_C__ */

#ifdef __AUCONN_C__
# define EXTERN_AUCONN 
#else
# define EXTERN_AUCONN extern 
#endif

EXTERN_AUCONN int main(int argc,char *argv[],char *env[]);
EXTERN_AUCONN void cpConnOpt(ConnOpt *new,ConnOpt *org);
EXTERN_AUCONN int setdefaultSndForm(char *commname);
EXTERN_AUCONN int getarg(int argc,char *argv[],char *env[],int *dataonly,
			 int fnamepos[],ConnOpt opt[],int omode[],
			 int oparam[]);
EXTERN_AUCONN void initdefvar(int format);
EXTERN_AUCONN int getP(int argc,char *argv[],int *j,int *Omode,int *Oparam);
EXTERN_AUCONN int getL(int argc,char *argv[],int *j,ConnOpt *opt);
EXTERN_AUCONN void usage(char *comname,int form);

#endif /* __AUCONN_H__ */
