#
# yomi perl  (ѿ, subroutine, )
# yomi-lib.pl ver 0.5
# 
# 03/05 1999
# 05/07 2000
# 06/21 2000
# 08/16 2000
# 
# $Id: yomi-lib.pl,v 1.17 2007-02-09 18:56:06+09 shige Exp $
#
########## package name ##########
package yomi;
########## require libraries ########## 
BEGIN{
    if ($main::USETEXTKAKASI) {
	require Text::Kakasi;
	import Text::Kakasi qw/ getopt_argv do_kakasi /;
    }
    else{
	require IPC::Open2;
	import IPC::Open2 qw/ open2 /;
    }
    if ($main::JPERL) {
	require I18N::Japanese;
	import I18N::Japanese qw/re/;
    }
    else{ 
	require Encode;
	require encoding;
	import encoding "euc-jp";
    }
}
########## Ȥ main ѿ ##########
# $main::KAKASI		: kakasi  path
# $main::KAKASIOP	: kakasi  option
# $main::AUCONN		: auconn  path
# $main::AUCONNOP	: auconn  option
# $main::AUPLAY		: auplay  path
# $main::DEBUG1		: Ĥ餹 (0) script ή (1)
# $main::KUTENKUGIRI	: Զڤ꤫ (0) ڤ꤫ (1)
# $main::NUMFORCE	: () ȸ뤫 (1) '('  ')' Ȥߤ뤫 (0)
# $main::PAUSE		:  pause 뤫 (1) ʤ (0)
# $main::QUIET		: ɽ򤷤ʤ (1) 뤫 (0)
# $main::NUMBETAYOMI	: ٥ɤߤ뤫 (1) ѲǤȤ (0)
# $main::ALPHABETAYOMI	: alphabet ٥ɤߤ뤫 (1) ѲǤȤ (0)
# $main::SHLESS		: -d  shless ѤνϤ⤹
# $main::SHLESSSTR	: shless Ѥ comment Ƭʬ
# $main::AULENGTH	: auconn  -L option (==> $main::AUCONNOP  merge)
# $main::AUSPEED	: auconn  -S option (==> $main::AUCONNOP  merge)
# $main::LASTNULLNUM	: ʸκǸղä null ο
# $main::USETEXTKAKASI	: Text::Kakasi Ȥ (1) open2() Ȥ (0)
# $main::JPERL		: jperl  (1) perl-5.8.X  (0) 
# $main::SKIPCHAR	: üʸɤФ (1) ɤफ (0)
# $main::SKIPALPHA	: ե٥åȤɤФ (1) ɤफ (0)
# $main::SPACE1NULL	: space Τߤ 1 null Ȥ뤫 (0)
# $main::REPLACEDSPACE	: SPACE1NULL ΤȤ space ֤ʸ
# $main::PATHRANDOMMODE : ǸѥΥ⡼ 
#                         (n: 硢s: ʸ衢w: ñ衢e: )
#
# $main::DEBUG2		: DEBUG option no.2 (1)
# $main::DEBUG3		: DEBUG option no.3 (1)
#
########## global ѿ ##########
# $lastmojishu		: ñʸ
# @datas		: 衢뤤϶ν buffer
#
########## main Ѥδؿ ##########
# main::put1file($file)	: 1 Ĥ file $file 
# main::putCR()		:  buffer μºݤνϤ clear
# main::pause()		: pause() ؿ (key Ԥ)
#
########## local Ѥδؿ ##########
# ##### ̤ routine #####
# sub put1word($word)	: ñ $word  buffer 
# 
# sub putword($word,$shu)	: $word ʸ $shu ˹礦 subroutine 
#				: (&put1word() β)
#
# ##### &putword() ˸ƤФ subroutine #####
# sub putunknown($word)	: Ƚ̤ǤʤʸФ subroutine
# sub puthira($word)	: Ҥ餬ʤñФ subroutine
# sub putnum($num)	: Ф subroutine
# sub putcharnum($word)	: () (==> ) Ф subroutine
# sub putchar($word)	: üʸФ subroutine
# sub putkutouten($word): Ф subroutine
# 
# ##### β #####
# sub putnumless10000($num)	: 10000 ̤ο buffer 
# sub pushnum($c)	: au file ̾ (1 ʬ)  buffer 
# sub pushhira($c)	: Ҥ餬 1 ʸ $c  buffer 
# sub pushhira2($c)	: au file ̾ (1 ʬ)  buffer 
# 
# ##### ܴؿ #####
# sub mojishu($word)	: ñ $word ʸȽ
# sub putspace($j)	: space $j Ĥ buffer 
# sub connect($lastc,$cur)	: ʸ ($lastc,$cur) 򸫤Ƥδ֤
#				: space ʤʤ鿿֤ͤ
#
########## sub routines ##########
########## main Ѥ sub routines ##########
sub main::put1file{ 
    local($file)=@_;
    local($f2str,$PATT,$putstr);
    local(@f2strlist,@line);
    local($tmp,$tmp2);

    $f2str="";
    if($file =~ /^-$/){
	while(<STDIN>){
	    $f2str .= $_;
	}
    }
    else{
	open(FILE0,$file) || return -1;
	while(<FILE0>){
	    $f2str .= $_;
	}
	close FILE0;
    }
    if ($main::USETEXTKAKASI) { 
	# getopt_argv(split(' ',$main::KAKASIOP)) && return -2;
	# for Text::Kakasi 2.X
	getopt_argv('kakasi', split(' ',$main::KAKASIOP)) && return -2; 
    }
    else{	    
	open2(FILE2,FILE1,"$main::KAKASI $main::KAKASIOP") || return -2;
    }
    $PATT = "[$PATTERNkuten]" if $main::KUTENKUGIRI; 
    $PATT = "\n" unless $main::KUTENKUGIRI; 
    while($f2str ne ""){
	if($f2str =~ /$PATT/){
	    $putstr = $` . $&;
	    $f2str = $';
	}
	else{
	    $putstr = $f2str;
	    $f2str = "";
	}
	# shige 12/13 2006
	$putstr =~ s/[ \t]/ $main::REPLACEDSPACE /g if $main::SPACE1NULL;

	if ($main::KUTENKUGIRI){ 
	    $putstr =~ s/^\s+//;
	    $putstr =~ s/\s*\n\s*//g;
	    $putstr =~ s/\s+$//;
	    $putstr .= "\n";
	}
	if ($main::JPERL) { 
	    $tmp = $putstr;
	}
	else{
            $tmp=Encode::encode('euc-jp' => $putstr); 
	}
	if ($main::USETEXTKAKASI) { 
	    $tmp2=do_kakasi($tmp);
	}
	else{
	    print FILE1 $tmp;
	    $tmp2 = <FILE2>;
	}
	if ($main::JPERL) { 
	    $_ = $tmp2;
	}
	else{
	    $_=Encode::decode('euc-jp' => $tmp2);
	}

	print STDERR "DEBUG: (in,out)=($tmp,$_)\n" if $main::DEBUG3; 
	s/\s+$PATTERNchouon//g;
	@line = split;
	do{
	    $lastmojishu = "";
	    @datas = ();
	    foreach $j (@line){
		&put1word($j);
	    }
	    $putstr=$_ if $main::PUTAFTERFILTER; 
	    # shige 08/30 2006
	    $putstr =~ s/ *$main::REPLACEDSPACE */ /g if $main::SPACE1NULL;

	    if ($main::SHLESS){ 
		print $main::SHLESSSTR, $putstr;  
	    }
	    elsif(!$main::QUIET){ 
		print STDERR $putstr;
	    }
	    &main::putCR(); 
	}while($main::PAUSE && &main::pause());
    }
    unless ($main::USETEXTKAKASI) {  
	close FILE1;
	close FILE2;
    }
    return 0;
}

## q ==> λ
## r ==> ƤӤιԤ
sub main::pause{
    local($_);
    
    $_=getc(main::KEY);  
    # die if $_ =~ /[qQ]/;
    exit if $_ =~ /[qQ]/;
    seek(main::KEY,0,1); 
    return 1 if $_ =~ /[rR]/;
    return 0;
}

sub put1word{
    local($word)=@_;
    local($currentmojishu);

#debug
    print "[debug3]: [",$word,"]\n" if $main::DEBUG3; 
    $currentmojishu=&mojishu($word);
#debug
    print "[debug3]: [",$currentmojishu,"]\n" if $main::DEBUG3; 
    #&putspace(1) unless &connect($lastmojishu,$currentmojishu);
    # 12/25 2006 shige
    if (&connect($lastmojishu,$currentmojishu) == 0){
	&putspace(1);
	push(@datas,"-Pr1") if $main::PATHRANDOMMODE eq 'w';
    } 
    &putword($word,$currentmojishu);
    $lastmojishu = $currentmojishu;
}

# 12/25 2006 shige
# $main::PATHRANDOMMODE  'n','s','e' ξ auconn ˤĤ륪ץ
%pathrandomop = (
		 'n' => "-Pr0", # 
		 's' => "-Pr1", # ν
		 'e' => "-Pr2", # ˥
		 'w' => "-Pr1", # ǽΥΥå
		 );

# system() Ȥꡢfile hundle Ȥ®
sub main::putCR{
    local($comline,$j);

    return if $#datas < 0;
    $comline = "$main::AUCONN $main::AUCONNOP";
    # 12/25 2006 shige
    $comline .= " $pathrandomop{$main::PATHRANDOMMODE}" 
	if $main::PATHRANDOMMODE =~ /[nswe]/;
    &putspace($main::LASTNULLNUM) if $main::LASTNULLNUM > 0;
    if ($main::DEBUG1){ 
	print join(' ',("$comline",@datas," $main::AUPLAY")),"\n";
    }
    else{
	system(join(' ',("$comline",@datas," $main::AUPLAY")));
    }
    @datas = ();
}

########## ܴؿ ##########
sub mojishu{
    local($word)=@_;

    return "S" if $main::SPACE1NULL && $word =~ /$main::REPLACEDSPACE/;
    return "S" if $word =~ /^[$PATTERNkutouten]+$/;	#  
    return "H" if $word =~ /^[$PATTERNHIRA]+$/;		# Ҥ餬
    return "K" if $word =~ /^.+\[[$PATTERNHIRA]+\]$/;	# 
    return "N" if $word =~ /^$PATTERNNUM$/;		# 
    return "CN" if $word =~ /^$PATTERNCHARNUM$/;	# ()
    return "C" if $word =~ /^[$PATTERNCHAR]+$/;		# 
    # return "-" if($word =~ /^$/); 			# 
    return "U";						# Unknown
}

# data/null/null.au  $j  @datas list ˲ä
sub putspace{
    local($j)=@_;

    #push(@datas,"$NULLDATADIR/null.au " x $j) if($j>0);
    push(@datas,"null " x $j) if $j>0;
}

#  + Ҥ餬ʤϤĤ롣
#  + Ҥ餬ʤĤ롣
sub connect{
    local($lastc,$cur)=@_;
    
    return 1 if $main::SPACE1NULL;
    return 1 unless $lastc;
    return 1 if $cur eq "S";
    return 1 if $lastc eq "K" && $cur eq "H";
    return 1 if $lastc eq "C" && $cur eq "H";
    return 1 if $lastc eq "N" && $cur eq "H";
    return 0;
}

########## 餬 ##########
sub putword{
    local($word,$shu)=@_;

    #debug
    # push(@datas,$word);
    if( $shu eq "K" ){ # 
	$word =~ s/^.+\[([$PATTERNHIRA]+)\]$/\1/;
	&puthira($word);
    } elsif( $shu eq "H" ){ # Ҥ餬 
	&puthira($word); 
    } elsif( $shu eq "N" ){ #  
	&putnum($word); 
    } elsif( $shu eq "CN" ){ # ()
	&putcharnum($word);
    } elsif( $shu eq "C" ){ # 
	&putchar($word);
    } elsif( $shu eq "S" ){ # 
	&putkutouten($word);
    } elsif( $shu eq "U" ){ # Unknown
	&putunknown($word);
    }
}

########## Unknown ##########
sub putunknown{
    local($word)=@_;

    print STDERR "Error word:", $word, "\n"; 
}

########## Ҥ餬 ##########
$PATTERNkana 	= "-";
$PATTERNchouon	= "ݰ";
$PATTERNmaru	= "";
$PATTERNdakuten	= "ɡ";
$PATTERNHIRA 	= "$PATTERNkana$PATTERNchouon$PATTERNmaru$PATTERNdakuten";
$PATTERNsmall 	= "";
$PATTERNttsu 	= "";
$PATTERNkanasp 	= "$PATTERNchouon$PATTERNmaru$PATTERNdakuten$PATTERNsmall";

%H2a = (
	'', 'a',
	'', 'i',
	'', 'u',
	'', 'e',
	'', 'o',
	'', 'ka',
	'', 'ki',
	'', 'ku',
	'', 'ke',
	'', 'ko',
	'', 'sa',
	'', 'si',
	'', 'su',
	'', 'se',
	'', 'so',
	'', 'ta',
	'', 'chi',
	'', 'tsu',
	'', 'te',
	'', 'to',
	'', 'na',
	'', 'ni',
	'', 'nu',
	'', 'ne',
	'', 'no',
	'', 'ha',
	'', 'hi',
	'', 'hu',
	'', 'he',
	'', 'ho',
	'', 'ma',
	'', 'mi',
	'', 'mu',
	'', 'me',
	'', 'mo',
	'', 'ya',
	'', 'yu',
	'', 'yo',
	'', 'ra',
	'', 'ri',
	'', 'ru',
	'', 're',
	'', 'ro',
	'', 'wa',
	'', 'o',
	'', 'n',

	'', 'ga',
	'', 'gi',
	'', 'gu',
	'', 'ge',
	'', 'go',
	'', 'za',
	'', 'zi',
	'', 'zu',
	'', 'ze',
	'', 'zo',
	'', 'da',
	'', 'zi',
	'', 'zu',
	'', 'de',
	'', 'do',
	'', 'ba',
	'', 'bi',
	'', 'bu',
	'', 'be',
	'', 'bo',
	'', 'pa',
	'', 'pi',
	'', 'pu',
	'', 'pe',
	'', 'po',

	'', 'kya',
	'', 'kyu',
	'', 'kyo',
	'', 'sha',
	'', 'shu',
	'', 'sho',
	'', 'cha',
	'', 'chu',
	'', 'cho',
	'ˤ', 'nya',
	'ˤ', 'nyu',
	'ˤ', 'nyo',
	'Ҥ', 'hya',
	'Ҥ', 'hyu',
	'Ҥ', 'hyo',
	'ߤ', 'mya',
	'ߤ', 'myu',
	'ߤ', 'myo',
	'', 'rya',
	'', 'ryu',
	'', 'ryo',

	'', 'gya',
	'', 'gyu',
	'', 'gyo',
	'', 'ja',
	'', 'ju',
	'', 'jo',
	'Ӥ', 'bya',
	'Ӥ', 'byu',
	'Ӥ', 'byo',
	'Ԥ', 'pya',
	'Ԥ', 'pyu',
	'Ԥ', 'pyo',

	'դ', 'fa',
	'դ', 'fi',
	'դ', 'fe',
	'դ', 'fo',
	'Ƥ', 'ti',
	'Ȥ', 'tu',
	'', 'je',
	'Ǥ', 'dyi',
	'Ǥ', 'dyu',

	'', 'ttsu',

	'', 'error',
	);

%Dakuon = (
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   '', '',
	   );

%Handakuon = (
	      '', '',
	      '', '',
	      '', '',
	      '', '',
	      '', '',
	      );

%Small2Large = (
		'', '',
		'', '',
		'', '',
		'', '',
		'', '',
		'', '',
		'', '',
		'', '',
		'', '',
		);

# ľ
# category ʬϡpattern Ȥꡢ󻲾Ȥ®
sub puthira{
    local($word)=@_;
    local(@chars,$j,$c,$c1);
    
    @chars=split(//,$word);
    for($j=0;$j<=$#chars;$j++){
	while($j<=$#chars){ # üʸǤʤΤõ
	    last unless ($chars[$j] =~ /[$PATTERNkanasp]/);
	    $j++;
	}
	last if ($j>$#chars);
	$c=$chars[$j];
	next unless $H2a{$c}; # Ϥʤ
	if($c eq ''){ #  => ϤƼ
	    &pushhira($c);
	    next;
	}
	if(++$j>$#chars){ &pushhira($c); last; }
	$c1=$chars[$j];
	if($c1 =~ /[$PATTERNdakuten]/){ #  => 
	    $c=$Dakuon{$c} if $Dakuon{$c};
	    if(++$j>$#chars){ &pushhira($c); last; }
	    $c1=$chars[$j];
	}
	elsif($c1 =~ /[$PATTERNmaru]/){ # Ⱦ => 
	    $c=$Handakuon{$c} if $Handakuon{$c};
	    if(++$j>$#chars){ &pushhira($c); last; }
	    $c1=$chars[$j];
	}
	if($c1 =~ /[$PATTERNsmall]/){ # 
	    if($H2a{$c . $c1}){ 
		$c .= $c1;
		if(++$j>$#chars){ &pushhira($c); last; }
		$c1=$chars[$j];
	    }
	    else{ # ʤȤ
		&pushhira($c);
		$chars[$j--]=$Small2Large{$c1};
		next;
	    }
	}
	if($c1 =~ /[$PATTERNchouon]/){ # Ĺ
	    &pushhira($c);
	    $c1=$H2a{$c}; $c=chop $c1;
	    while($j<=$#chars){
		last unless $chars[$j] =~ /[$PATTERNchouon]/;
		&pushhira2($c);
		$j++;
	    }
	}
	else{
	    &pushhira($c);
	}
	$j--;
    }
}

sub pushhira{
    local($c)=@_;

    #push(@datas,"$HIRADATADIR/$H2a{$c}.au") if $H2a{$c};
    push(@datas,"$H2a{$c}") if $H2a{$c};
}

sub pushhira2{
    local($c)=@_;

    #push(@datas,"$HIRADATADIR/$c.au") if $c;
    push(@datas,"$c") if $c;
}

##########  ##########
#$PATTERNnonzero = '^[+-]?[1-9]\d*$';
#$PATTERNzero = '^[+-]?0$';
#$PATTERNNUM = "$PATTERNnonzero|$PATTERNzero";
#
## 1 ʾοɤȤϡȤƤγ任ǤʤʸȤ
## 4 夺ڤʤȤʤ
#sub putnum{
#    local($num)=@_;
#    local($m);
#
#    if($num >= 100000000){ 
#	&putchar($num); return ;
#    }
#    if($num =~ /^\+/){
#	&puthira("פ餹");
#    }
#    elsif($num =~ /^\-/){
#	&puthira("ޤʤ");
#	$num *= -1;
#    }
#    if($num == 0){
#	&pushnum("0"); return;
#    }
#    if(($m=int($num/10000))>0){
#	&putnumless10000($m);
#	&pushnum("0000");
#    }
#    &putnumless10000($num%10000);
#}
#
##
## ľ
##
## ɽγĥ
##
## 1) ɽκ
##    [a] 3  ',' ɽ = "[1-9]\d?(, ?\d{3})*"
##        " ?" ϼäƤ⤤
##	  ==> 䡢ʤ
##    [b] 4  ',' ɽ = "[1-9]\d{1,2}(, ?\d{4})*"
##        " ?" ϼäƤ⤤
##	  ==> 䡢ʤ
##    [c] ʬ = "(\.\d+)?"
##    礹ȡ
##    "^[+-]?[1-9](\d*|\d?(, ?\d{3})*|\d{1,2}(, ?\d{4})*)(\.\d+)?$"
## 2) ϡ㤨 ".315" ˤбƤʤϡ̤ʤ
##    ȤñȤˤä¿ʬڡ
## 3) ̾ 0  "" ɤब"0.2" ̾ "줤Ƥ" ɤࡣ
##    ξʬɬפ
## 
$PATTERNnonzero = '[+-]?[1-9](\d*|\d?(,\d{3})*|\d{1,2}(,\d{4})*)';
$PATTERNzero = '[+-]?0';
$PATTERNdecimal = '\.\d+';
$PATTERNNUM = "($PATTERNnonzero|$PATTERNzero)?($PATTERNdecimal)?";

#@keta4 = ("","ޤ","","礦","礦");
@keta4 = ("","ޤ","","硼","硼");

sub putnum{
    local($num)=@_;
    local($m,$dec,$keta,$rest,$num1);

    $dec="";
    if($num =~ /^\+/){
	&puthira("פ餹");
	$num =~ s/^\+//;
    } 
    elsif($num =~ /^\-/){
	&puthira("ޤʤ");
	$num =~ s/^\-//;
    }
    $num1=$num;
    $num =~ s/, ?//g;
    ($num,$dec)=split(/\./, $num) if $num =~ /\./;
    # bug fix 09/21 2000 shige
    if($num eq "0" && $dec eq ""){ 
	&pushnum("0"); 
	return; 
    }
    if($num eq "0" && $dec ne ""){ # Ex. 0.315...
	&puthira("줨Ƥ");
	&putchar($dec);
	return;
    }
    $keta=int(length($num)/4);
    $keta ++ if ($rest=length($num)%4)>0;
    # Ĥ support 롣
#debug
#print $keta,$#keta4,"\n";
    if($keta-1>$#keta4){ # 礭
	&putchar($num1);
	return;
    }
    if($rest>0){
	$num1=int(substr($num,0,$rest));
	&putnumless10000($num1);
	&puthira($keta4[$keta-1]) if $keta>1;
	$num=substr($num,$rest);
	$keta--;
    }
    for(;$keta>1;$keta--){
	$num1=int(substr($num,0,4));
#debug
#print $num1,"\n";
	if($num1>0){
	    &putnumless10000($num1);
	    &puthira($keta4[$keta-1]);
	}
	$num=substr($num,4);
    }
    &putnumless10000($num) if $keta>0 && $num>0;
    if($dec ne ""){
	&puthira("Ƥ");
	&putchar($dec);
	return;
    }
}

sub putnumless10000{
    local($num)=@_;
    local($m);

    return if($num<=0 || $num>=10000);
    if($num>=1000){
	$m=int($num/1000);
	if($m == 3 || $m == 8 ){ # 3000, 8000 ؤб
	    $m*=1000; &pushnum("$m");
	}
	else{
	    &pushnum("$m") if $m>=2;
	    &pushnum("1000");
	}
	$num %= 1000;
    }
    if($num>=100){
	$m=int($num/100);
	if($m == 3 || $m == 6 || $m == 8){ # 300, 600, 800 ؤб
	    $m*=100; &pushnum("$m");
	}
	else{
	    &pushnum("$m") if $m>=2;
	    &pushnum("100");
	}
	$num %= 100;
    }
    if($num>=10){
	$m=int($num/10);
	&pushnum("$m") if $m>=2;
	&pushnum("10");
	$num %= 10;
    }
    &pushnum("$num") if $num>=1;
}

sub pushnum{
    local($c)=@_;

    #push(@datas,"$NUMDATADIR/$c.au") unless ($c eq "");
    if ( $main::NUMBETAYOMI ){ 
	&pushnumbeta($c);
    }
    else{
	push(@datas,"$c") unless $c eq "";
    }
}    

%NumBeta = ( 
	    '0', '',
	    '1', '',
	    '2', '',
	    '3', '',
	    #'4', '',
	    '4', '',
	    '5', '',
	    '6', '',
	    '7', 'ʤ',
	    #'7', '',
	    #'7', 'Ҥ',
	    '8', 'Ϥ',
	    '9', '夦',
	    #'9', '',
	    '10', '夦',
	    '100', 'Ҥ㤯',
	    '1000', '',
	    '300','Ӥ㤯',
	    '600','äԤ㤯',
	    '800','ϤäԤ㤯',
	    '3000','󤼤',
	    '8000','Ϥä',
	    );

sub pushnumbeta{
    local($c)=@_;

    &puthira($NumBeta{$c}) if $NumBeta{$c};
}

########## alphabetʸüʸ ##########
$PATTERNCHARNUM = '^\([-\d]+\)$'; # '
$PATTERNCHAR = '][)(}{@&#\\\/\'",.!%`=^|~;:*?><\w\+\-\$';

%Char = (
	 '[', 'ä',
	 #'[', 'ä',
	 ']', 'äȤ',
	 #']', 'äȤ',
	 '(', '礦ä',
	 #'(', 'ޤ뤫ä',
	 ')', '礦äȤ',
	 #')', 'ޤ뤫äȤ',
	 '{', '夦ä',
	 '}', '夦äȤ',
	 '@', 'äȤޡ',
	 '&', 'ѡ',
	 #'&', '',
	 '#', '㡼',
	 '\\', 'Фää',
	 '/', 'ä',
	 #'/', '',
	 '\'', '',
	 '"', '֤뤯',
	 '.', 'ɤä',
	 #'.', 'Ԥꤪ',
	 ',', '',
	 '!', 'Ӥäޡ',
	 '%', 'ѡ',
	 '`', 'Фä',
	 '=', '',
	 #'=', '',
	 '^', 'Ϥä',
	 '|', 'Ƥܤ',
	 '~', '',
	 #'~', 'ʤ',
	 #'~', 'ˤ',
	 ';', 'ߤ',
	 ':', '',
	 '*', 'ꤹ',
	 #'*', '',
	 '?', 'äޡ',
	 #'?', 'ϤƤ',
	 '>', 'ʤ',
	 '<', '礦ʤ',
	 '+', 'פ餹',
	 #'+', '',
	 '-', 'Ϥդ',
	 #'-', 'ޤʤ',
	 #'-', 'Ҥ',
	 '_', 'С',
	 '$', 'ɤ', #'
	 );
	
sub putcharnum{
    local($word)=@_;

    #$word =~ s/[\(\)]//g;
    #$word =~ s/\(\)//g;
    $word =~ s/^\((.*)\)$/\1/;
    if ( $main::NUMFORCE ) { 
	&putchar("("); &putnum($word); &putchar(")");
    }     
    else{
	&putchar($word);
    }
}

sub putchar{
    local($word)=@_;
    local(@chars,$j);

    $word =~ s/$main::REPLACEDSPACE/ /g if $main::SPACE1NULL;
    @chars=split(//,$word);
    foreach $j (0..$#chars){
	if($chars[$j] =~ /[0-9]/){
	    &pushnum($chars[$j]);
	}
	elsif($chars[$j] =~ /[a-zA-Z]/){
	    $chars[$j] =~ y/a-z/A-Z/;
	    #push(@datas,"$ALPHDATADIR/$chars[$j].au");
	    if ( $main::ALPHABETAYOMI ){ 
		&pushalphabeta($chars[$j]) unless $main::SKIPALPHA;
	    }
	    else{
		push(@datas,"$chars[$j]") unless $main::SKIPALPHA;
	    }
	}
	elsif($chars[$j] =~ /[$PATTERNCHAR]/){
#debug
#print "[debug2]: [",$chars[$j],"][",$Char{$chars[$j]},"]\n";
	    &puthira($Char{$chars[$j]}) 
		if ! $main::SKIPCHAR && $Char{$chars[$j]};
	}
	# shige 08/30 2006 
	elsif($chars[$j] =~ / / && $main::SPACE1NULL){
	    &putspace(1);
        }
    }
}

%AlphaBeta = (
	      'A','',
	      'B','Ӥ',
	      'C','',
	      'D','Ǥ',
	      #'D','Ǥ',
	      'E','',
	      'F','',
	      'G','',
	      'H','',
	      #'H','ä',
	      'I','',
	      'J','',
	      #'J','',
	      'K','',
	      #'K','',
	      'L','',
	      'M','',
	      'N','',
	      'O','',
	      #'O','',
	      'P','Ԥ',
	      'Q','夦',
	      'R','',
	      'S','',
	      'T','Ƥ',
	      'U','椦',
	      'V','֤',
	      'W','֤',
	      'X','',
	      #'X','ä',
	      'Y','襤',
	      'Z','ä',
	      #'Z','',
	      );

sub pushalphabeta{
    local($c)=@_;

    &puthira($AlphaBeta{$c}) if ! $main::SKIPALPHA && $AlphaBeta{$c};
}


##########  ##########
$PATTERNkuten	= ".";
$PATTERNtouten	= ",";
$PATTERNkutouten = $PATTERNkuten . $PATTERNtouten;

%Kutou2space = (
		'.',  3,
		'', 3,
		'', 3,
		',',  2,
		'', 2,
		'', 2,
		'@', 1,		# for $main::REPLACEDSPACE
		);

sub putkutouten{
    local($word)=@_;
    local(@chars,$j);

    $word =~ s/$main::REPLACEDSPACE/@/g if $main::SPACE1NULL;
    @chars=split(//,$word);    
    foreach $j (0..$#chars){
#debug
#print "[debug1]: [",$j,"][",$chars[$j],"][",$Kutou2space{$chars[$j]},"]\n";
	&putspace($Kutou2space{$chars[$j]}) if $Kutou2space{$chars[$j]};
    }
}

1;
